
//////////////////////////////////////////////////////////////////////////////////////////
//HID֘A̐錾ƃN
#include <wtypes.h>
#include <setupapi.h>

extern "C" {

	# ifdef __MINGW32__
		#  include <../ddk/hidsdi.h>// from WinDDK
	# else
		#include <../api/hidsdi.h>
	# endif
}

#pragma comment(lib, "setupapi.lib")
#pragma comment(lib,"hid.lib")

#include	"Onahole.h"



//////////////////////////////////////////////////////////////////////////////////////////
HID_Controller :: HID_Controller() 
: m_handle( INVALID_HANDLE_VALUE ), m_bOpen( false )
{
	Init();
}

HID_Controller::~HID_Controller()
{
	Close();
}

bool HID_Controller::IsEnable()
{
	if( m_handle == INVALID_HANDLE_VALUE )
		return false;

	return true;
}

bool HID_Controller::IsOpen()
{
	return m_bOpen != false;
}

void HID_Controller::Init()
{
	m_handle = INVALID_HANDLE_VALUE;
	m_bOpen = false;
	m_uGetReportTimeOut = 600;
	m_uSetReportTimeOut = 500;
	m_wFeatReportBufferLength = 0;
	m_wInReportBufferLength = 0;
	m_wOutReportBufferLength = 0;

	m_VendorId = 0;
	m_ProductId = 0;

	m_bOpen = false;

	memset( &m_Read, 0, sizeof( m_Read ) );
	memset( &m_Write, 0, sizeof( m_Write ) );

}

bool HID_Controller::Open( int nVendorID, int nProductID )
{
	if( m_bOpen )
		return true;

	//ftHgA̐lgp
	int VendorId = nVendorID;
	int ProductId = nProductID;
	if( VendorId==-1 || ProductId==-1 )
	{
		VendorId = 0x0483;
		ProductId = 0x5750;
	}

	HANDLE handle = INVALID_HANDLE_VALUE;
	handle = _Open( VendorId, ProductId );
	if( handle == INVALID_HANDLE_VALUE )
	{
		MessageBox( NULL, "error:\r\nIiz[ڑĂȂȂH", "HID::Open", MB_OK );
		return false;
	}

	if( m_handle != INVALID_HANDLE_VALUE )
	{
		BOOL bret = CloseHandle(m_handle);
		if( !bret )
			MessageBox( NULL, "error:\r\nIiz[ڑĂȂȂH", "CloseHandle", MB_OK );
	}

	m_handle = handle;				//nh
	m_VendorId = (WORD)VendorId;	//x_[ID
	m_ProductId = (WORD)ProductId;	//v_NgID

	m_bOpen = true;
	
	m_Read.hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	m_Write.hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);

	return true;
}

void HID_Controller::Close()
{

	if( m_bOpen )
	{	
		if( ( m_handle != INVALID_HANDLE_VALUE ) && (m_handle != NULL) )
		{
			CloseHandle( m_handle );
			CloseHandle( m_Read.hEvent );
			CloseHandle( m_Write.hEvent );
			m_handle = INVALID_HANDLE_VALUE;
			m_bOpen = false;
		}
	}
	
}

HANDLE HID_Controller::_Open( int nVendorID, int nProductID )
{
	GUID hidGuid;
	HANDLE hDevHandle = INVALID_HANDLE_VALUE;
	HDEVINFO hDevInfo;
	HIDD_ATTRIBUTES Attributes;
	PSP_DEVICE_INTERFACE_DETAIL_DATA pspDidd;
	SP_DEVICE_INTERFACE_DATA spDid;

	BYTE status = HID_DEVICE_SUCCESS;

	if( m_bOpen )
	{
		status = HID_DEVICE_ALREADY_OPENED;
	}

	HidD_GetHidGuid(&hidGuid);
	hDevInfo = SetupDiGetClassDevs(&hidGuid, NULL, NULL, DIGCF_PRESENT|DIGCF_DEVICEINTERFACE|DIGCF_ALLCLASSES);

	if( status == HID_DEVICE_SUCCESS )
	{
		USHORT i;
		for(i = 0; i < 128;i++)
		{
			hDevHandle = INVALID_HANDLE_VALUE;
			memset(&spDid, 0, sizeof(SP_DEVICE_INTERFACE_DATA)); // spDid Clear;
			spDid.cbSize = sizeof(SP_DEVICE_INTERFACE_DATA);
			//ݐڑĂtraüꗗ̂traȕ肷
			if(!SetupDiEnumDeviceInterfaces(hDevInfo, NULL, &hidGuid, i, &spDid)) continue;
			DWORD dwRequiredLength = 0;
			SetupDiGetDeviceInterfaceDetail(hDevInfo, &spDid, NULL, 0, &dwRequiredLength, NULL);
			pspDidd = (PSP_DEVICE_INTERFACE_DETAIL_DATA)malloc(dwRequiredLength);
			pspDidd->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);
			if(SetupDiGetDeviceInterfaceDetail(hDevInfo, &spDid, pspDidd, dwRequiredLength, &dwRequiredLength, NULL))
			{
				//ēǂݏt@Cnh쐬
				hDevHandle = CreateFile(pspDidd->DevicePath, GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);

				if(hDevHandle != INVALID_HANDLE_VALUE)
				{
					Attributes.Size = sizeof(Attributes);
					if(HidD_GetAttributes(hDevHandle, &Attributes))
					{
						//x_[IDƃv_NgIDv邩ǂ
						if(nVendorID == Attributes.VendorID && nProductID == Attributes.ProductID)
						{
							free(pspDidd);
							break;
						}
					}
					CloseHandle(hDevHandle);
					hDevHandle = INVALID_HANDLE_VALUE;
				}
			}
			free(pspDidd);
		}
	}
	return hDevHandle;
}

BYTE HID_Controller::WriteFile( BYTE* pBuffer, DWORD dwBufferSize )
{
	DWORD time1, time2;

	BYTE status = HID_DEVICE_SUCCESS;

	if( m_bOpen )
	{
		DWORD bytesWritten = 0;

		if (!::WriteFile(m_handle, pBuffer, dwBufferSize, &bytesWritten, NULL))
		{
			if( GetLastError() == ERROR_IO_PENDING )
			{
				DWORD waitStatus;
                time1 = GetTickCount();

				waitStatus = WaitForSingleObject(m_Write.hEvent, m_uSetReportTimeOut);

				time2 = GetTickCount();

				if (waitStatus == WAIT_OBJECT_0)
				{
					GetOverlappedResult( m_handle, &m_Write, &bytesWritten, FALSE);

				}else if( waitStatus == WAIT_TIMEOUT )
				{
					status = HID_DEVICE_TRANSFER_TIMEOUT;
					//CancelIo( m_handle );
					m_bOpen = false;

				}else
				{
					status = HID_DEVICE_TRANSFER_FAILED;
					//CancelIo( m_handle );
					m_bOpen = false;
				}
			}else
			{
				status = HID_DEVICE_TRANSFER_FAILED;
				m_bOpen = false;
			}
		}
	}else
	{
		status = HID_DEVICE_NOT_OPENED;
	}

	return status;

}

BYTE HID_Controller::ReadFile( BYTE* pBuffer, DWORD dwBufferSize )
{
	BYTE status = HID_DEVICE_SUCCESS;
	DWORD time, bytesRead = 0;

	if( m_bOpen )
	{
		if( !::ReadFile( m_handle, pBuffer, dwBufferSize, &bytesRead, NULL ) )
		{
			DWORD error = GetLastError();

			time = GetTickCount();

			if( error == ERROR_IO_PENDING )
			{
				DWORD waitStatus = WaitForSingleObject(m_Read.hEvent, m_uGetReportTimeOut);

				if( waitStatus == WAIT_OBJECT_0 )
				{
					GetOverlappedResult(m_handle, &m_Read, &bytesRead, FALSE);

				}else if( waitStatus == WAIT_TIMEOUT )
				{
					status = HID_DEVICE_TRANSFER_TIMEOUT;
					//CancelIo(m_handle);
					m_bOpen = false;

				}else
				{
					status = HID_DEVICE_TRANSFER_FAILED;
					//CancelIo(m_handle);
					m_bOpen = false;
				}

			}else
			{
				status = HID_DEVICE_TRANSFER_FAILED;
				m_bOpen = false;
				//m_handle = INVALID_HANDLE_VALUE;
			}
		}

	}else
	{
		status = HID_DEVICE_NOT_OPENED;
	}

	return status;
}

BYTE HID_Controller::FlushBuffer()
{
	BYTE status = HID_DEVICE_SUCCESS;
	m_wInBufferUsed = 0;

	if( FALSE == HidD_FlushQueue( m_handle ) )
	{
		if( ERROR_INVALID_HANDLE == GetLastError() )
			status = HID_DEVICE_HANDLE_ERROR;
		else
			status = HID_DEVICE_UNKNOWN_ERROR;

		if( status != HID_DEVICE_SUCCESS )
			return status;
	}

	return HID_DEVICE_SUCCESS;
}

BYTE HID_Controller::GetFeature( BYTE* pBuffer )
{
	BYTE status = HID_DEVICE_SUCCESS;
	DWORD bytesRead;

	if( m_bOpen )
	{
		if( !HidD_GetFeature( m_handle, pBuffer, m_wFeatReportBufferLength ) )
		{
			DWORD waitStatus = WaitForSingleObject( m_Read.hEvent, m_uGetReportTimeOut );

			if( waitStatus == WAIT_OBJECT_0 )
			{
				GetOverlappedResult( m_handle, &m_Read, &bytesRead, FALSE );
				
			}else if( waitStatus == WAIT_TIMEOUT )
			{
				status = HID_DEVICE_TRANSFER_TIMEOUT;
				CancelIo( m_handle );

			}else
			{
				status = HID_DEVICE_TRANSFER_FAILED;
				CancelIo( m_handle );
			}

		}else
		{
			status = HID_DEVICE_TRANSFER_FAILED;
		}

	}else
	{
		status = HID_DEVICE_NOT_OPENED;
	}

	return status;
}

BYTE HID_Controller::SetFeature( BYTE* pBuffer )
{
	BYTE status = HID_DEVICE_SUCCESS;
	DWORD bytesWritten;

	if( m_bOpen )
	{
		if( !HidD_SetFeature( m_handle, pBuffer, m_wFeatReportBufferLength ) )
		{
			if( GetLastError() == ERROR_IO_PENDING )
			{
				DWORD waitStatus = WaitForSingleObject(m_Write.hEvent, m_uSetReportTimeOut);

				if( waitStatus == WAIT_OBJECT_0 )
				{
					GetOverlappedResult( m_handle, &m_Write, &bytesWritten, FALSE );

				}else if( waitStatus == WAIT_TIMEOUT )
				{
					status = HID_DEVICE_TRANSFER_TIMEOUT;
					CancelIo( m_handle );
				}else
				{
					status = HID_DEVICE_TRANSFER_FAILED;
					CancelIo( m_handle );
				}

			}else
			{
				status = HID_DEVICE_TRANSFER_FAILED;
			}
		}

	}else
	{
		status = HID_DEVICE_NOT_OPENED;
	}

	return status;
}



//////////////////////////////////////////////////////////////////////////////////////////
COnahole :: COnahole()
{
	this->m_bPause = false;
	this->m_nPattern = 0;
	this->m_nSpeed = 0;

	//ĐAp^[0, x0
	BYTE data[ONAHO_STATUS_MAX] = { 0x00, 0x3C, 0x30, 0x31, 0x35, 0x32, 0x30, 0x30, 0x30, 0x30, 0x30, 0x01, 0x02, 0x03, 0x68, 0x3E };
	::memcpy( m_OnahoStatus, data, ONAHO_STATUS_MAX );
}

COnahole :: ~COnahole()
{
	Quit();
	Close();
}

//Iiz̃Xe[^X؂ւ
bool COnahole :: ChangeStatus( BYTE* pData, int nDataSize )
{
	//ʐMłԂȂꍇB
	if( !IsEnable() ) return false;

	if( !m_bOpen )
	{
		//1I[vĂ݂
		if( !Open( -1, -1 ) )
			return false;
	}

	BYTE ret = this->WriteFile( pData, nDataSize );
	if( ret != HID_DEVICE_SUCCESS )
	{
		return false;//"s܂B"
	}

	return true;
}

//|[YȂׂ̂
bool COnahole :: IsPause()
{
	if( m_OnahoStatus[PlayIndex] == 0x31 )
		return true;

	return false;
}

//|[Y
void COnahole :: Pause()
{
	m_OnahoStatus[PlayIndex] = 0x31;	//PauseR[h
	ChangeStatus( m_OnahoStatus, ONAHO_STATUS_MAX );
}

//X^[g|[Y
void COnahole :: Start()
{
	m_OnahoStatus[PlayIndex] = 0x30;	//PauseR[h
	ChangeStatus( m_OnahoStatus, ONAHO_STATUS_MAX );
}

//~
void COnahole :: Quit()
{
	SetPattern(0);
	SetLevel(0);
}


//p^[ύX
bool COnahole :: SetPattern( int nPattern )
{
	this->m_nPattern = nPattern;
	this->m_bPause = false;

	BYTE bChange = nPattern & 0x000F;
	bChange |= 0x30;
	m_OnahoStatus[PatternIndex] = bChange;
	bool ret = ChangeStatus( m_OnahoStatus, ONAHO_STATUS_MAX );

	return ret;
}

//xύX
bool COnahole :: SetLevel( int nLevel )
{
	this->m_nSpeed = nLevel;
	this->m_bPause = false;

	BYTE bChange = nLevel & 0x000F;
	bChange |= 0x30;
	m_OnahoStatus[LevelIndex] = bChange;
	bool ret = ChangeStatus( m_OnahoStatus, ONAHO_STATUS_MAX );

	return ret;
}

bool COnahole :: Set( int pattern, int speed )
{
	bool bPat = false;
	bool bLev = false;

	bPat = SetPattern( pattern );
	if( bPat )
	bLev = SetLevel( speed );

	return (bool)(bPat&bLev);
}


bool	COnahole :: AddPattern()
{
	this->m_nPattern++;
	this->m_bPause = false;
	this->SetPattern( this->m_nPattern );
	return true;
}
bool	COnahole :: SubPattern()
{
	this->m_nPattern--;
	this->m_bPause = false;
	this->SetPattern( this->m_nPattern );
	return true;
}
bool	COnahole :: AddSpeed()
{
	this->m_nSpeed++;
	this->m_bPause = false;
	this->SetLevel( this->m_nSpeed );
	return true;
}
bool	COnahole :: SubSpeed()
{
	this->m_nSpeed--;
	this->m_bPause = false;
	this->SetLevel( this->m_nSpeed );
	return true;
}
